VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form FrmAverage 
   Caption         =   "Form2"
   ClientHeight    =   6495
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   9855
   LinkTopic       =   "Form2"
   ScaleHeight     =   6495
   ScaleWidth      =   9855
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid MsgFilter 
      Height          =   1695
      Left            =   2820
      TabIndex        =   6
      Top             =   60
      Width           =   2955
      _ExtentX        =   5212
      _ExtentY        =   2990
      _Version        =   393216
   End
   Begin VB.CommandButton CmdProceed 
      Caption         =   "Proceed"
      Height          =   375
      Left            =   1620
      TabIndex        =   5
      Top             =   840
      Width           =   1095
   End
   Begin MSFlexGridLib.MSFlexGrid MsgAverages 
      Height          =   1515
      Left            =   60
      TabIndex        =   4
      Top             =   2160
      Width           =   5355
      _ExtentX        =   9446
      _ExtentY        =   2672
      _Version        =   393216
   End
   Begin VB.ComboBox CboToDate 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "dd/MM/yyyy"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1086
         SubFormatType   =   3
      EndProperty
      Height          =   315
      Left            =   1080
      TabIndex        =   1
      Top             =   420
      Width           =   1695
   End
   Begin VB.ComboBox CboFromDate 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "dd/MM/yyyy"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1086
         SubFormatType   =   3
      EndProperty
      Height          =   315
      Left            =   1080
      TabIndex        =   0
      Top             =   60
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "To date:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   420
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "From date:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   60
      Width           =   855
   End
End
Attribute VB_Name = "FrmAverage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
   With MsgFilter
      .FixedCols = 0
      .Cols = 4
   End With
   With MsgAverages
      .FixedCols = 0
      .Cols = 4
   End With
End Sub

Private Sub Form_Resize()
Dim COLidx As Integer
   With MsgFilter
      .Width = Width - .Left - 180
      .Height = Height / 2
      For COLidx = 0 To 3
          .ColWidth(COLidx) = (.Width - 330) / 4
      Next COLidx
   End With
   With MsgAverages
      .Width = Width - 240
      .Top = MsgFilter.Top + MsgFilter.Height + 120
      .Height = Height - .Top - 600
      For COLidx = 0 To 3
          .ColWidth(COLidx) = (.Width - 330) / 4
      Next COLidx
   End With
End Sub

Private Sub CmdProceed_Click()
Dim ARRRECSETidx As Integer
Dim FIRSTRECidx As Integer
Dim DATEused As String
Dim RECcount As Integer
Dim SUMlevel As Double
Dim SUMstorage As Double
Dim SUMarea As Double
' clear and reset the grids
    With MsgFilter
        .Clear
        .FixedRows = 1
        .Rows = 1
        .TextMatrix(0, 0) = "Date"
        .TextMatrix(0, 1) = "W/Level"
        .TextMatrix(0, 2) = "Storage"
        .TextMatrix(0, 3) = "S/Area"
    End With
    With MsgAverages
        .Clear
        .FixedRows = 1
        .Rows = 1
        .TextMatrix(0, 0) = "Date"
        .TextMatrix(0, 1) = "Av W/Level"
        .TextMatrix(0, 2) = "Av Storage"
        .TextMatrix(0, 3) = "Av S/Area"
    End With
' check combo boxes text
   If CboFromDate.Text = "" Or CboToDate.Text = "" Then
      MsgBox "Select both From and To date first.", vbExclamation + vbOKOnly, "Select Date"
      Exit Sub
   End If
   If CDate(CboFromDate.Text) > CDate(CboToDate.Text) Then
      MsgBox "The 'From' date is later than the 'To' date!", vbExclamation + vbOKOnly, "Date Error"
      Exit Sub
   End If
' filling the MsgFilter grid
   For ARRRECSETidx = 0 To UBound(ARRRECSET, 2)
      If CDate(ARRRECSET(0, ARRRECSETidx)) >= CDate(CboFromDate.Text) And _
          CDate(ARRRECSET(0, ARRRECSETidx)) <= CDate(CboToDate.Text) Then
      MsgFilter.AddItem ARRRECSET(0, ARRRECSETidx) & vbTab & ARRRECSET(2, ARRRECSETidx) & vbTab & _
      ARRRECSET(3, ARRRECSETidx) & vbTab & ARRRECSET(4, ARRRECSETidx)
      End If
   Next
' search for the selected date range from the array arrRecSet
   SUMlevel = 0
   SUMstorage = 0
   SUMarea = 0
   RECcount = 0
   For ARRRECSETidx = 0 To UBound(ARRRECSET, 2)
      If CDate(ARRRECSET(0, ARRRECSETidx)) = CDate(CboFromDate.Text) Then
         FIRSTRECidx = ARRRECSETidx
         DATEused = ARRRECSET(0, ARRRECSETidx)
         Exit For
      End If
   Next
   ' run through the next records until date > CboToDate
   For ARRRECSETidx = FIRSTRECidx To UBound(ARRRECSET, 2)
      ' the same date: add
      If ARRRECSET(0, ARRRECSETidx) = DATEused Then
         SUMlevel = SUMlevel + ARRRECSET(2, ARRRECSETidx)
         SUMstorage = SUMstorage + ARRRECSET(3, ARRRECSETidx)
         SUMarea = SUMarea + ARRRECSET(4, ARRRECSETidx)
         RECcount = RECcount + 1
         ' if last record is used, dump result
         If ARRRECSETidx = UBound(ARRRECSET, 2) Then
            MsgAverages.AddItem DATEused & vbTab & Format(SUMlevel / RECcount, "0.000") & vbTab & _
            Format(SUMstorage / RECcount, "0.000") & vbTab & Format(SUMarea / RECcount, "0.000")
         End If
      ' else next date is different
      Else
         ' set previously found data in grid
         MsgAverages.AddItem DATEused & vbTab & Format(SUMlevel / RECcount, "0.000") & vbTab & _
         Format(SUMstorage / RECcount, "0.000") & vbTab & Format(SUMarea / RECcount, "0.000")
         ' start new record set if date < "ToDate"
         If CDate(ARRRECSET(0, ARRRECSETidx)) <= CDate(CboToDate.Text) Then
            SUMlevel = ARRRECSET(2, ARRRECSETidx)
            SUMstorage = ARRRECSET(3, ARRRECSETidx)
            SUMarea = ARRRECSET(4, ARRRECSETidx)
            RECcount = 1
            DATEused = ARRRECSET(0, ARRRECSETidx)
            ' if this is the last record (only 1 line)
            If ARRRECSETidx = UBound(ARRRECSET, 2) Then
               MsgAverages.AddItem DATEused & vbTab & Format(SUMlevel / RECcount, "0.000") & vbTab & _
               Format(SUMstorage / RECcount, "0.000") & vbTab & Format(SUMarea / RECcount, "0.000")
            End If
         ' else stop
         Else
            Exit Sub
         End If
      End If
   Next
End Sub

